<template>
  <div class="home d-flex flex-row flex-ai-center h-100 layout"
    :class="{ moving }">

    <div class="sidebar d-flex flex-col flex-ai-start h-100">
      <Navbar class="w-100 navbar" :page.sync="page"/>

      <Tab :page="page" class="d-flex flex-1 w-100 tab">

        <!-- chat/requests tab -->
        <Tab :page="chatPage" data-page="tab-page-chat"
          class="d-flex flex-col flex-1 max-w-100 bg-white">
          <!-- messages/notifications switcher -->
          <div class="text-left chat-switcher mh-4 mt-3 mb-2">
            <a @click="chatPage = 'chaat'" class="ph-1">Messages</a>
            <a @click="chatPage = 'notifications'" class="ph-1">
              Notifications
              </a>
            <span class="selected" :class="{ first: chatPage === 'chaat',
              second: chatPage === 'notifications'}">
            </span>
          </div>

          <!-- requests + chatlist tab -->
          <div data-page="tab-page-chaat" class="d-flex flex-col flex-1
            max-w-100">
            <Requests />
            <ChatList/>
          </div>

          <!-- notifications tab -->
          <div data-page="tab-page-notifications" class="d-flex flex-col flex-1
            max-w-100">
            <ul v-if="Object.keys(allNotifications).length > 0">
              <li v-for="(n, i) of allNotifications" :key="n._id" :data="n" class="d-flex flex-row flex-ai-center">
                <span>{{ n.text }} </span><button class="icon-button" @click="deleteNotification(i)"><v-icon name="times"/></button><br>
              </li>
            </ul>
          </div>

        </Tab>

        <!-- User settings tab -->
        <User data-page="tab-page-else"/>
      </Tab>
    </div>

    <Tab class="swipe d-flex h-100 flex-ai-center flex-jc-center flex-1"
      :page="swipePage"
    >
      <Swipe data-page="tab-page-swipe"/>
      <div data-page="tab-page-messages" class="d-flex flex-row flex-1
        flex-as-stretch max-w-100" style="position: relative">
        <Messages class="max-w-100 flex-1"/>
        <ProfileView />
      </div>
    </Tab>

    <!-- notifications -->
    <div class="notifications-container d-flex flex-col">
      <NotificationDialog v-for="n of notifications" :key="n._id" :data="n"/>
    </div>
  </div>
</template>

<script>
// @ is an alias to /src
import Navbar from '@/components/Navbar.vue';
import ChatList from '@/components/ChatList.vue';
import Tab from '@/components/Tab.vue';
import Messages from '@/components/Messages.vue';
import ProfileView from '@/components/ProfileView.vue';
import NotificationDialog from '@/components/NotificationDialog.vue';
import Swipe from '@/components/Swipe.vue';
import User from '@/components/User.vue';
import Requests from '@/components/Requests.vue';
import { mapState } from 'vuex';
// import Search from '@/components/Search.vue';

export default {
  name: 'home',
  data: () => ({
    page: 'chat',
    swipePage: 'swipe',
    chatPage: 'chaat',
    moving: false,

    match: null,
    fetchingMatch: false,
    showAbout: false,

    picIndex: 0,

    _move: null,
  }),
  computed: {
    ...mapState(['msgUser', 'messages']),
    notifications() {
      return this.$store.state.notifications.filter((n) => !n.read);
    },
    allNotifications() {
      return this.$store.state.notifications;
    },
  },
  watch: {
    msgUser() {
      this.swipePage = this.msgUser ? 'messages' : 'swipe';
    },
  },
  components: {
    Navbar,
    Swipe,
    User,
    ChatList,
    Requests,
    NotificationDialog,
    Tab,
    Messages,
    ProfileView,
    // Search,
  },
  methods: {
    logout() {
      this.$bus.$emit('logout');
    },
    getMatches() {
      this.$store.dispatch('getMatches')
        .catch((e) => e);
    },
    deleteNotification(i) {
      this.$store.state.notifications.splice(i, 1);
    }
  },
  mounted() {
    // Call socket init
    this.$bus.$emit('socket-init');

    this.images = [ ...this.$store.state.user.media, ];

    // Get all conversations
    this.getMatches();

    let lay = document.querySelector('.layout');
    let sid = document.querySelector('.sidebar');
    let swi = document.querySelector('.swipe');

    let touch = null;

    const move = (left) => {
      if (lay.clientWidth >= 550)
        return ;

      if (left == '-100%') {
        sid.style.left = '-100%';
        swi.style.left = '0';
      }
      else if (left == '0') {
        sid.style.left = '0';
        swi.style.left = '100%';
      }
      else {
        sid.style.left = `${left - lay.clientWidth}px`;
        swi.style.left = `${left}px`;
      }
    };

    this._move = move;

    /**
     * Connect all bus events
     */
    this.$bus.$on('open-messages', () => {
      move('-100%');
      this.swipePage = 'messages';
    });

    this.$bus.$emit('init-socket');

    this.$bus.$on('open-swipe', () => {
      move('-100%');
      this.swipePage = 'swipe';
    });

    lay.addEventListener('touchstart', (e) => {
      if (lay.clientWidth < 550)
        touch = { startX: e.touches[0].clientX };
    });

    lay.addEventListener('touchcancel', () => {
      touch = null;
      this.moving = false;
    });

    lay.addEventListener('touchmove', (e) => {
      if (!touch)
        return ;

      touch.endX = e.changedTouches[0].clientX;
      let dx = touch.endX - touch.startX;
      let rect = sid.getBoundingClientRect();

      if (this.moving) {
        move(e.changedTouches[0].clientX);
      }
      else {
        if (Math.abs(dx) < 20) return ;
        // If initial move is to the right, and it started with the sidebar
        // hidden, and it started in the first 20% of the screen
        if (dx > 0 && touch.startX > rect.right &&
            touch.startX <= .2 * lay.clientWidth) {
          // swipe right
          move(e.changedTouches[0].clientX);
          this.moving = true;
        }
        // If initial move is to the left, and it started with the sidebar
        // visible, and it started in the last 20% of the screen
        else if (dx < 0 && touch.startX < rect.right &&
                 touch.startX >= .8 * lay.clientWidth) {
          move(e.changedTouches[0].clientX);
          this.moving = true;
        }
      }

    });

    lay.addEventListener('touchend', () => {
      if (!touch) {
        this.moving = false;
        touch = null;
        return ;
      }

      let dx = touch.endX - touch.startX;

      if (this.moving) {
        this.moving = false;
        if (dx > 0) {
          // swipe right
          if (Math.abs(dx) >= .2 * lay.clientWidth &&
              touch.endX >= .5 * lay.clientWidth)
            move('0');
          else
            move('-100%');
        }
        else {
          // swipe left
          if (Math.abs(dx) >= .2 * lay.clientWidth &&
              touch.endX <= .5 * lay.clientWidth)
            move('-100%');
          else
            move('0');
        }
      }

      touch = null;
      this.moving = false;
    }, false);
  },
};
</script>

<style scoped>
.layout {
  background: #f5f7fa;
}

.sidebar {
  flex-basis: 25%;
  min-width: 325px;
  max-width: 375px;
  z-index: 99;

  background: #edf4f6;
}

.swipe {
  background: #edf4f6;
}

.tab {
  overflow-y: auto !important;
}

.swipe {
  border-left: 1px solid #e0e4e9;
}

.navbar {
  box-shadow: 0 1px 8px 0 rgba(0,17,25,.27);
}

.layout:not(.moving) > * {
  transition: left .15s ease-out;
}

.chat-switcher {
  display: inline-grid;
  grid-template-columns: auto auto;
  align-self: flex-start;
  text-align: center;
  overflow: hidden;
}

.chat-switcher a {
  color: var(--color-dark);
  font-weight: bold;
  cursor: pointer;
}

.chat-switcher .selected {
  display: inline-block;
  height: 3px;
  background: var(--color-pink);
  width: 1fr;

  animation-duration: .25s;
  animation-fill-mode: forwards;
  animation-iteration-count: 1;
}

.notifications-container {
  position: fixed;
  width: 25%;
  max-width: 400px;
  top: 0;
  right: 0;
}

@keyframes gosecond {
  from {
    grid-column-start: 2;
    grid-column-end: 3;
    transform: translateX(-100%);
  }
  to {
    grid-column-start: 2;
    grid-column-end: 3;
    transform: translateX(0%);
  }
}

@keyframes gofirst {
  from {
    grid-column-start: 1;
    grid-column-end: 2;
    transform: translateX(100%);
  }
  to {
    grid-column-start: 1;
    grid-column-end: 2;
    transform: translateX(0%);
  }
}

.chat-switcher .selected.second {
  animation-name: gosecond;
}

.chat-switcher .selected.first {
  animation-name: gofirst;
}

@media only screen and (max-width: 550px) {
  .layout > * {
    position: fixed;
    width: 100%;
    height: 100%;
    border: none;
  }

  .navbar { box-shadow: none; }
  .swipe  { border: none; }

  .sidebar {
    left: -100%;
    width: 100% !important;
    max-width: unset;
    min-width: 100%;
  }

  .notifications-container {
    width: 100%;
    max-width: 100%;
  }
}
</style>
